﻿
record Person(string FirstName, string LastName, int Age);

record struct Coordinate(double Longitude, double Latitude);

readonly record struct ImmuCoordinate(double Latitude, double Longitude);

class Program {
	public static void Main(string[] args) {
		var tuple = ("Pavel", "Jezek", 100);
		Console.WriteLine(tuple);

		(string FirstName, string LastName, int Age) tuple2 = ("Pavel", "Jezek", 100);
		Console.WriteLine(tuple2);

		Person p = new("Pavel", "Jezek", 100);
		Console.WriteLine(p);

		Person p2 = new(FirstName: "Pavel", LastName: "Jezek", Age: 100);
		Console.WriteLine(p);

		Coordinate coord = new(Latitude: 50.0755, Longitude: 14.4378);
		Console.WriteLine(coord);
		Console.WriteLine(coord.Latitude);

		ImmuCoordinate immuCoord = new(Latitude: 50.0755, Longitude: 14.4378);
		Console.WriteLine(immuCoord);
		Console.WriteLine(immuCoord.Latitude);

		immuCoord = immuCoord with { Longitude = 14.5 };
		Console.WriteLine(immuCoord);

		var (lat, lon) = immuCoord;
		Console.WriteLine($"lat: {lat}");
		Console.WriteLine($"lon: {lon}");
	}
}

